#ifndef __BILATERAL_PLUGIN_H_
#define __BILATERAL_PLUGIN_H_

// **********************************************
// To compile plugins (win32):
// 
// define PLUGIN_EXPORTS on the command line
//
// in Visual Studio:
// Project->Settings->C/C++, Category Preprocessor
// add PLUGIN_EXPORTS to 'preprocessor definitions'
// ***********************************************

#include "../../../Core/Interfaces/src/PluginInterface.h"

/**
 * This class implements a template plugin which may be used
 * to implement more plugins. It does nothing but show a message
 * on <code>std err</code> on execution.
 *
 * @author Oliver Knoll
 * @version 1.2
 */
class Bilateral_Plugin : public PluginInterface {

public:
	
	PLUGIN_API Bilateral_Plugin();
	PLUGIN_API virtual ~Bilateral_Plugin();

	// *************************
	// interface PluginInterface
	// *************************

	PLUGIN_API void execute();
	PLUGIN_API bool isAvailable() const;

private:
	
	bool checkPluginAvailability() const;
	
};

// ****************
// access functions
// ****************

// extern "C" is needed so those functions can be accessed
// with GetProcAddress() (WIN32) and dlsym() (UNIX) respective
extern "C" {
	PLUGIN_API PluginInterface *createPlugin();
	PLUGIN_API const char *getPluginName();
	PLUGIN_API const char *getPluginDescription();
}

#endif  // __BILATERAL_PLUGIN_H_
